<?php



if(function_exists('sanitize_to_vc_opts_array')==false) {
	function sanitize_to_vc_opts_array($arr) {


		$ilab = 0;
		$params_arr = array();
		foreach ( $arr as $lab => $opt ) {

			$params_arr[ $ilab ] = array(
				'type'       => $opt['type'],
				'param_name' => $lab,

				//            'context' => $opt['context'],
			);

			if ( isset( $opt['title'] ) ) {

				$params_arr[ $ilab ]['heading'] = $opt['title'];


			}
			if ( isset( $opt['heading'] ) ) {

				$params_arr[ $ilab ]['heading'] = $opt['heading'];


			}
			if ( isset( $opt['type'] ) ) {
				$params_arr[ $ilab ]['type'] = $opt['type'];
				if ( $opt['type'] == 'select' ) {
					$params_arr[ $ilab ]['type'] = 'dropdown';
				}
				if ( $opt['type'] == 'text' ) {
					$params_arr[ $ilab ]['type'] = 'textfield';
				}
				if ( $opt['type'] == 'image' ) {
					$params_arr[ $ilab ]['type'] = 'attach_image';
				}
				if ( $opt['type'] == 'upload' ) {
					$params_arr[ $ilab ]['type'] = 'dzs_add_media_att';

					if ( isset( $opt['upload_input_type'] ) ) {
						if ( $opt['upload_input_type'] == 'native' ) {
							if ( isset( $opt['library_type'] ) && $opt['library_type'] == 'image' ) {
								$params_arr[ $ilab ]['type'] = 'attach_image';
							}
						}
					}
				}
				if ( $opt['type'] == 'repeater' ) {
					$params_arr[ $ilab ]['type'] = 'param_group';
				}
			}
			if ( isset( $opt['sidenote'] ) ) {
				$params_arr[ $ilab ]['description'] = $opt['sidenote'];
			}
			if ( isset( $opt['default'] ) ) {
				$params_arr[ $ilab ]['std']     = $opt['default'];
				$params_arr[ $ilab ]['default'] = $opt['default'];
			}
			if ( isset( $opt['options'] ) ) {
				$params_arr[ $ilab ]['value'] = $opt['options'];
			}

			if ( isset( $opt['library_type'] ) ) {
				$params_arr[ $ilab ]['library_type'] = $opt['library_type'];
			}

			if ( isset( $opt['class'] ) ) {
				$params_arr[ $ilab ]['class'] = $opt['class'];
			}

			if ( isset( $opt['dependency'] ) ) {
				if ( isset( $opt['dependency'][0] ) ) {

					$params_arr[ $ilab ]['dependency'] = $opt['dependency'][0];
				} else {

					$params_arr[ $ilab ]['dependency'] = $opt['dependency'];
				}
			}

			$ilab ++;
		}

		return $params_arr;


	}
}
if(function_exists('vc_map')){




	$this->options_array_player = array(



		'template' => array(
			'type' => 'select',
			'title' => __("Template"),
			'admin_label' => true,
			'sidenote' => sprintf(__("leave the type to default for the player to decide wheter it is a souncloud link of a self hosted mp3")),


			'context' => 'content',
			'options' => array(
				array(
					'label'=>__("Template Simple",'dzsprs'),
					'value'=>'template-simple',
				),
				array(
					'label'=>__("Template Hood",'dzsprs'),
					'value'=>'template-hood',
				),
				array(
					'label'=>__("Template Side",'dzsprs'),
					'value'=>'template-side',
				),
				array(
					'label'=>__("Template Mobile",'dzsprs'),
					'value'=>'template-mobile',
				),
				array(
					'label'=>__("Template Hip",'dzsprs'),
					'value'=>'template-hip',
				),
				array(
					'label'=>__("Template Bal",'dzsprs'),
					'value'=>'template-bal',
				),
				array(
					'label'=>__("Template Simple Alt",'dzsprs'),
					'value'=>'template-simple-2',
				),
			),
			'default' => 'simple',
		),

		'feed' => array(
			'type' => 'select',
			'title' => __("Feed from"),
			'sidenote' => sprintf(__("Make the container cover the full width of the page")),


			'context' => 'content',
			'options' => array(
				array(
					'label'=>__("Normal",'dzsprs'),
					'value'=>'normal',
				),
				array(
					'label'=>__("Products",'dzsprs'),
					'value'=>'woocommerce',
				),

			),
			'default' => 'off',
		),






		'js_breakout' => array(
			'type' => 'select',
			'title' => __("Horizontal breakout"),
			'sidenote' => sprintf(__("Make the container cover the full width of the page")),


			'context' => 'content',
			'options' => array(
				array(
					'label'=>__("Normal",'dzsprs'),
					'value'=>'off',
				),
				array(
					'label'=>__("Force fullwidth",'dzsprs'),
					'value'=>'on',
				),

			),
			'default' => 'off',
		),

		'custom_ph' => array(
			'type' => 'text',
			'title' => __("Custom Height"),
			'sidenote' => sprintf(__("Input a custom height in px, to limit the height of the container. For example for %s pixels, input %s, or leave blank for it to cover the full widdow height",'dzsprs'),'500','<strong>500px</strong>'),


			'context' => 'content',

			'default' => '',
		),

		'count' => array(
			'type' => 'text',
			'title' => __("Number of items"),
			'sidenote' => sprintf(__("Input the number of items to be retrieved from woocommerce products",'dzsprs'),'500','<strong>500px</strong>'),


			'context' => 'content',

			'default' => '',
			'dependency'=>array(

				array(
					'element'=>'feed',
					'value'=>array('woocommerce'),
				),
			)
		),

		'cat' => array(
			'type' => 'text',
			'title' => __("Category"),
			'sidenote' => sprintf(__("Input the category slug, if you want to show a specific category, or leave blank to show any category")),


			'context' => 'content',

			'default' => '',
			'dependency'=>array(

				array(
					'element'=>'feed',
					'value'=>array('woocommerce'),
				),
			)
		),

	);











	$params_arr = array();
	$ilab = 0;


	foreach($this->options_array_player as $lab => $opt){

		$params_arr[$ilab] = array(
			'type'=>$opt['type'],
			'param_name'=>$lab,
			'heading' => $opt['title'],
			//            'context' => $opt['context'],
		);

		if(isset($opt['type'])){
			$params_arr[$ilab]['type'] = $opt['type'];
			if($opt['type']=='select'){
				$params_arr[$ilab]['type'] = 'dropdown';
			}
			if($opt['type']=='text'){
				$params_arr[$ilab]['type'] = 'textfield';
			}
			if($opt['type']=='textfield'){
				$params_arr[$ilab]['type'] = 'textfield';
			}
			if($opt['type']=='textarea'){
				$params_arr[$ilab]['type'] = 'textarea';
			}
			if($opt['type']=='textarea_html'){
				$params_arr[$ilab]['type'] = 'textarea_html';
			}
			if($opt['type']=='image'){
				$params_arr[$ilab]['type'] = 'attach_image';
			}
			if($opt['type']=='upload'){
				$params_arr[$ilab]['type'] = 'dzs_add_media_att';

				if(isset($opt['upload_input_type'])){
					if($opt['upload_input_type']=='native'){
						if(isset($opt['library_type']) && $opt['library_type']=='image'){
							$params_arr[$ilab]['type'] = 'image';
						}
					}
				}
			}
			if($opt['type']=='repeater'){
				$params_arr[$ilab]['type'] = 'param_group';

				$params_arr[$ilab]['params'] = sanitize_to_vc_opts_array($opt['params']);
			}
		}
		if(isset($opt['sidenote'])){
			$params_arr[$ilab]['description'] = $opt['sidenote'];
		}
		if(isset($opt['default'])){
			$params_arr[$ilab]['std'] = $opt['default'];
			$params_arr[$ilab]['default'] = $opt['default'];
		}
		if(isset($opt['options'])){
			$params_arr[$ilab]['value'] = $opt['options'];
		}

		if(isset($opt['library_type'])){
			$params_arr[$ilab]['library_type'] = $opt['library_type'];
		}

		if(isset($opt['class'])){
			$params_arr[$ilab]['class'] = $opt['class'];
		}

		if(isset($opt['dependency'])){
			if(isset($opt['dependency'][0])){

				$params_arr[$ilab]['dependency'] = $opt['dependency'][0];
			}else{

				$params_arr[$ilab]['dependency'] = $opt['dependency'];
			}
		}

		$ilab++;
	}

//    print_r($params_arr);



	vc_map(array(
		"name" => __("Parallaxer Showcase"),

		"content_element" => true,
		"show_settings_on_create" => false,
		"is_container" => true,
		"as_parent" => array('only' => 'parallax_showcase_item'),
		"base" => "parallax_showcase",
		"class" => "",
		//        "front_enqueue_js" => $this->base_url.'vc/frontend_backbone.js',
		"category" => __('Content'),
		"js_view" => 'VcColumnView',
		"params" => $params_arr,
	));






	$params_item = sanitize_to_vc_opts_array(array(


		'thumb' => array(
			'type' => 'upload',
			'library_type' => 'image',
			'upload_type' => 'upload',
			'class' => '',
			'title' => __("Source"),
			'sidenote' => __("the image thumbnail"),

			'context' => 'content',
			'default' => '',
			'prefer_id' => 'on',
			'upload_input_type' => 'native',
		),

		'title' => array(
			'type' => 'textfield',
			'value' => '#',
			'heading' => 'Title',

			'default' => __("Title here"),
		),

		'subtitle' => array(
			'type' => 'textfield',
			'value' => '#',
			'heading' => 'Sub Title',
			'sidenote' => __("only for specific skins"),

			'default' => __("Subtitle here"),
		),



		'content' => array(
			'type' => 'textarea_html',
			'value' => '#',
			'heading' => __("Content"),
			'sidenote' => __("only for specific skins"),

			'default' => __("content here"),
		),

		'side_color' => array(
			'type' => 'textfield',
			'value' => '#',
			'heading' => 'Side Color',
			'sidenote' => __("only for specific skins"),

			'default' => '#ff0000',
		),
	));


	vc_map(array(
		"name" => esc_html__("Parallaxer Showcase Item",'dzsprs'),
		"base" => "parallax_showcase_item",
		'allowed_container_element' => 'parallax_showcase',
		'content_element' => true,
		"class" => "",

		"params" => $params_item,
	)
	);






}

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_Parallax_Showcase extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_Parallax_Showcase_Item extends WPBakeryShortCode {
	}
}