var coll_buffer=0;
var func_output='';
var fout = '';




function htmlEncode(arg) {
    return jQuery('<div/>').text(arg).html();
}


jQuery(document).ready(function($){

    var tinymce_settings = {
        some_setting: 1,
        plugins: 'hr paste colorpicker lists textcolor',
        skin: 'lightgray',
        theme_url: '/themes/modern/theme.min.js',
        toolbar: 'styleselect fontselect fontsizeselect | link bold italic blockquote  | hr copy paste color | forecolor backcolor | bullist numlist | alignleft aligncenter alignright | removeformat',
        menu: {

        }
        ,preview_styles: 'font-size color'
    };


    if(window.dzsprs_standard_options){

    }else{

        window.dzsprs_standard_options = [];
    }




    $('.shortcode-field').each(function(){
        var _t = $(this);

        window.dzsprs_standard_options.push(_t.attr('name'));
    })


    console.info('window.dzsprs_standard_options - ',window.dzsprs_standard_options);




    var startinit = '';
    var _form = $('.sg-form').eq(0);
    var _sg_items = $('.sgitems-con').eq(0);
    var _sg_sample = $('.sg-item-sample').eq(0);
    var _output = $('.shortcode-output').eq(0);

    if(window.dzsprs_startinit){
        startinit = window.dzsprs_startinit;
    }


    _sg_items.sortable({
        'items':'.sg-item-real'
        ,'handle':'.sort-ctrl'
        ,'placeholder':'sortable-placeholder'
        ,start: function(e,ui){

            console.log(e,ui);


            var _it = ui.item;


            var _ta = _it.find('textarea.content');


            _ta.removeClass('tinymce-active');
            var editorid = _ta.attr('id');


            //tinyMCE.execCommand('mceRemoveControl', false, editorid);

            var ed = tinyMCE.get(editorid);

            console.info('ed - ',ed);
            //console.info('editorid - ',editorid);



            _it.removeClass('active');

            if(ed && ed.remove){

                ed.remove();
            }
        }
        ,stop: function(e,ui){

            console.log('stop',e,ui);

            var _it = ui.item;






            setTimeout(function(){

                rename_fields();
            },100)

        }
    })

    $(document).on('change', '.thumb-field, .title-field,*[name=template]', handle_change);
    $(document).on('click', '.submit-shortcode,.sg-btn-add-item,.toggle-html-editor,.toggle-visual-editor,.sgitem-preview', handle_mouse);


    console.warn(' startinit - ',startinit);

    if(startinit ){



        $('.dzsprs-admin').append('<div class="misc-initSetup"><h5>Start Setup</h5></h5><p>'+htmlEncode(startinit)+'</p></div>');




        for(var key in window.dzsprs_standard_options){

            // console.info(key);
            lab = window.dzsprs_standard_options[key];
            res = get_shortcode_attr(lab, startinit);
            console.info(res, lab, top.dzsp_startinit);
            if(res){

                console.info(' $(\'*[name="\'+lab+\'"]\') -  ',$('*[name="'+lab+'"]'));

                $('*[name="'+lab+'"]').val(res['val']);
                $('*[name="'+lab+'"]').trigger('change');

            }
        }









        var lab = 'items';

        //console.info(startinit);
        var aux_val = get_shortcode_attr(lab, startinit);

        //console.info(lab,val);


        console.info('aux_val');
        console.info(aux_val);
        if(aux_val.val){


            var arr = JSON.parse(aux_val.val);


            console.error("ARR");

            console.info(arr);


            for(var lab in arr.items){
                add_sg_item(arr.items[lab]);
            }
        }


    }else{

        $('.sg-btn-add-item').trigger('click');
    }





    console.info("CEVA");
    //setTimeout(reskin_select, 10);




    $('#insert_single_player').bind('click', click_insert_single_player);




    setTimeout(function(){
        $('.thumb-field, .title-field').trigger('change');
    },100)

// Creates a new editor instance


    //console.log('ed - ',ed);


    function rename_fields(){
        _sg_items.children('.sg-item-real:not(.ui-sortable-placeholder)').each(function(){
            var _c = $(this);


            var ind = _c.parent().children('.sg-item-real:not(.ui-sortable-placeholder)').index(_c);



            _c.find('input,select').each(function(){
                var _t2 = $(this);

                var str = _t2.attr('data-sample-name');
                str = str.replace('[]','['+ind+']');
                _t2.attr('name',str);
            })

            var editor_id = 'editor-'+ind;

            _c.find('textarea.content').each(function(){
                var _t2 = $(this);

                _t2.attr('id',editor_id);


                var str = _t2.attr('data-sample-name');
                str = str.replace('[]','['+ind+']');
                _t2.attr('name',str);
            })




            if($('#'+editor_id).hasClass('tinymce-active')==false){

                $('#'+editor_id).addClass('tinymce-active tinymce-inited');

                var ed = new tinymce.Editor(editor_id, tinymce_settings
                    , tinymce.EditorManager);


                console.info('initing ed - ',ed);
                console.info('editor_id - ',editor_id);
                ed.render();
            }



            setTimeout(function(_arg){
                if(_arg.find('.mce-tinymce').length>1){
                    _arg.find('.mce-tinymce').eq(0).remove();
                    _arg.find('.mce-tinymce').eq(0).show();
                }else{

                    _arg.find('.mce-tinymce').eq(0).show();
                }
            },300,_c);


        })
    }


    function add_sg_item(pargs){


        var margs = {

        };

        if(pargs){
            margs = $.extend(margs,pargs);
        }

        console.warn('add_sg_item',margs);



        _sg_items.append(_sg_sample.clone());

        var _c = _sg_items.children().last();

        _c.removeClass('sg-item-sample').addClass('sg-item-real');

        var ind = _c.parent().children().index(_c);




        _c.find('.toggle-visual-editor').addClass('active');

        for(var lab in margs){

            console.info('lab - ',lab);
            console.info('margs[lab] - ',margs[lab]);
            console.info('_c.find(\'*[data-sample-name*="\'+lab+\'"]\') - ',_c.find('*[data-sample-name*="'+lab+'"]'));
            _c.find('*[data-sample-name*="['+lab+']"]').val(margs[lab]);
        }

        // Enforce initial active selection
        rename_fields();


    }


    function handle_change(e) {
        var _t = $(this);

        if (e.type == 'change') {
            if (_t.attr('name')=='template') {
                _t.parent().parent().parent().attr('data-selected-template',_t.val());
            }
            if (_t.hasClass('thumb-field')) {

                var _con = _t.parent().parent().parent().parent();

                _con.find('.the-thumb').css({
                    'background-image':'url('+_t.val()+')'
                })
            }
            if (_t.hasClass('title-field')) {

                var _con = _t.parent().parent().parent().parent();

                _con.find('.the-title').html(_t.val());
            }
        }
    }



    function handle_mouse(e){
        var _t = $(this);

        if(e.type=='click'){
            if(_t.hasClass('toggle-html-editor')){





                var _con = _t.parent().parent();
                var _ta = _con.find('textarea.content');


                var editorid = _ta.attr('id');


                _ta.removeClass('tinymce-active');
                tinyMCE.execCommand('mceRemoveControl', false, editorid);

                var ed = tinyMCE.get(editorid);

                //console.info('ed - ',ed);
                //console.info('editorid - ',editorid);


                if(ed.remove){

                    ed.remove();
                }

                _t.parent().children().removeClass('active');
                _t.addClass('active');


                return false;
            }
            if(_t.hasClass('toggle-visual-editor')){





                var _con = _t.parent().parent();
                var _ta = _con.find('textarea.content');

                var editorid = _ta.attr('id');



                console.info('ed - ',ed);
                console.info('editorid - ',editorid);

                var ed = new tinymce.Editor(editorid, tinymce_settings
                    , tinymce.EditorManager);

                ed.render();

                _ta.addClass('tinymce-active');

                _t.parent().children().removeClass('active');
                _t.addClass('active');


                return false;
            }
            if(_t.hasClass('sg-btn-add-item')){

                console.info("sg-btn-add-item", _form);


                add_sg_item(null);
                return false;

            }
            if(_t.hasClass('submit-shortcode')){

                console.info("CEVA", _form);


                prepare_fout_single();
                tinymce_add_content(fout);
                return false;





                return false;
            }
            if(_t.hasClass('sgitem-preview')){

                _t.parent().parent().children().removeClass('active');
                _t.parent().addClass('active');
            }
            if(_t.hasClass('insert-sample-tracks')){
                console.log('ceva', _t);




                var data = {
                    action: 'ajax_dzsprs_insert_sample_tracks'
                };


                $.ajax({
                    type: "POST",
                    url: ajaxurl,
                    data: data,
                    success: function(response) {
                        console.log(response);
                        window.location.reload();

                    },
                    error:function(arg){
                        if(typeof window.console != "undefined" ){ console.log('Got this from the server: ' + arg, arg); };
                    }
                });

                return false;
            }
            if(_t.hasClass('remove-sample-tracks')){
                console.log('ceva', _t);




                var data = {
                    action: 'ajax_dzsprs_remove_sample_tracks'
                };


                $.ajax({
                    type: "POST",
                    url: ajaxurl,
                    data: data,
                    success: function(response) {
                        console.log(response);
                        window.location.reload();

                    },
                    error:function(arg){
                        if(typeof window.console != "undefined" ){ console.log('Got this from the server: ' + arg, arg); };
                    }
                });

                return false;
            }


            if(_t.hasClass('sg-1')){
                //console.log('ceva2', _t);


                fout=window.sg1_shortcode;

                tinymce_add_content(fout);

            }
            if(_t.hasClass('sg-3')){
                //console.log('ceva2', _t);


                fout=window.sg3_shortcode;

                tinymce_add_content(fout);

            }


            if(_t.hasClass('sg-2')){
                //console.log('ceva2', _t);


                fout=window.sg2_shortcode;

                if(parent.dzsprs_prepare_footer_player){
                    parent.dzsprs_prepare_footer_player();
                }

                tinymce_add_content(fout);

            }
        }
    }



















    function tinymce_add_content(arg){
        //console.log(arg);

        if(top==window){
            jQuery('.shortcode-output').text(arg);
        }else{


            if(top.dzsprs_widget_shortcode){
                top.dzsprs_widget_shortcode.val(arg);

                top.dzsprs_widget_shortcode = null;

                console.info(top.close_zoombox2);
                if(top.close_zoombox2){
                    top.close_zoombox2();
                }
            }else{

                console.info(top.dzsprs_receiver);
                if(typeof(top.dzsprs_receiver)=='function'){
                    top.dzsprs_receiver(arg);
                }
            }

        }
    }









    function prepare_fout_single(){
        fout='';

//   [parallax_showcase template="template-simple" feed="woocommerce" count="6" items_data="items%5B0%5D%5Bthumb%5D=http%3A%2F%2Flocalhost%3A8888%2Fwordpress%2Fwp-content%2Fuploads%2F2017%2F02%2Fbeer.jpg&items%5B0%5D%5Btitle%5D=title1&items%5B0%5D%5Bsubtitle%5D=&items%5B0%5D%5Bcontent%5D=%3Cp%3Etest2+test2%3C%2Fp%3E&items%5B1%5D%5Bthumb%5D=http%3A%2F%2Flocalhost%3A8888%2Fwordpress%2Fwp-content%2Fuploads%2F2017%2F01%2Fsample.jpg&items%5B1%5D%5Btitle%5D=title2&items%5B1%5D%5Bsubtitle%5D=&items%5B1%5D%5Bcontent%5D=%3Cp%3E%26nbsp%3Btest1%3C%2Fp%3E"]

        fout+='[parallax_showcase';





        for(var i2 in dzsprs_standard_options){

            // console.info( 'lab - ',dzsprs_standard_options[i2]);
            fout+=add_attribute_to_shortcode(dzsprs_standard_options[i2]);
        }




//    console.info(_targetSettinger);


//        console.info(_c);

        if($('*[name=feed]').eq(0).val()=='normal'){

            _sg_items.find('.sg-item-real textarea').each(function(){
                var _t2 = $(this);

                var editorid = _t2.attr('id');


                var ed = tinyMCE.get(editorid);

                if(ed){

                    var cont = ed.getContent({format: 'raw'});

                    console.info("UPDATE MCE ed - ", ed);
                    console.info("UPDATE MCE editorid - ", editorid);
                    console.info("UPDATE MCE", cont);

                    _t2.val(cont);
                }
            });


            fout+=' items_data="'+(_form.serialize())+'"';
        }





        //$.post({
        //    url: ajaxurl
        //
        //    ,data: {
        //
        //        'action':'dzsprs_test'
        //        ,'postdata':_form.serialize()
        //    }
        //    ,success:function(res){
        //        //console.info(res);
        //    }
        //})




        fout+=']';


    }



    function add_attribute_to_shortcode(lab,pargs){


        var margs = {
            'call_from':'default'
            ,'attribute_type': 'attr'
        }

        if(pargs){
            margs = $.extend(margs,pargs);
        }

        var _c = $('*[name='+lab+']');
        var _par = null;


        if(_c.parent().hasClass('setting')){
            _par = _c.parent();

        }
        if(_c.parent().parent().hasClass('setting')){
            _par = _c.parent().parent();

        }
        if(_c.parent().parent().parent().hasClass('setting')){
            _par = _c.parent().parent().parent();

        }
        if(_c.parent().parent().parent().parent().hasClass('setting')){
            _par = _c.parent().parent().parent().parent();

        }

        // console.info(_c,_par);
        if(_par){
            if(_par.css('display')=='none'){
                return '';
            }
        }


        var fout2 = '';
        if(margs.attribute_type=='attr'){


            var val = '';

            if(_c.val()){
                val = _c.val();
            }
            if(lab=='qualities'){

                if(_c.val()){

                    val = val.replace(/\"/g,'{{quot}}');
                    val = val.replace(/\]/g,'{{patend}}');
                    // fout2+=' '+lab+'=\'' + _c.val() + '\'';
                }
            }else{
            }

            if(val){
                fout2+=' '+lab+'="' + val + '"';
            }
        }
        if(margs.attribute_type=='content'){

            //console.info(window.tinymce, window.tinyMCE);

            var ed = null;
            if(window.tinymce){
                ed = window.tinymce.get('content');

                //console.info(ed);

            }


            if(ed){

                if(ed){
                    fout2+=(ed.getContent({format: 'raw'}));
                }
            }else{

                if(_c.val()){
                    fout2+='' + _c.val() + '"';
                }
            }
        }

        return fout2;
    }

    function click_insert_single_player(){

        prepare_fout_single();
        tinymce_add_content(fout);
        return false;
    }




    function get_shortcode_attr(arg, argtext){

        // console.warn("HMM",arg);

        var regex_aattr = null;


        if(argtext.indexOf(arg+'=\'')>-1){

            regex_aattr  = new RegExp(' '+arg+'=\'(.*?)\'');
        }else{

            regex_aattr  = new RegExp(' '+arg+'="(.*?)"');
        }




        //console.log(regex_aattr, argtext);

        var aux = regex_aattr.exec(argtext);


        console.info("AUX - ",aux);
        if(arg=='cat'){

            // console.warn('aux - ',aux);
        }
        if(aux){
            var foutobj = {'full' : aux[0], 'val' : aux[1]};
            return foutobj;
        }



        return false;
    }
});

